#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <math.h>

#include "cdi/pci.h"
#include "cdi/io.h"
#include "cdi/misc.h"

#include "includes/ac97.h"

/*NOTE: Code kommt zum Teil aus lowlevel.brainsware.org/wiki/AC97 Stand: 3.8.2009*/

/*BTW: This Code sucks ass!*/

static void ac97_handle_interrupt(struct cdi_device* device);
//TODO: Volume als argument
void ac97_init_device(struct cdi_device* device){
    struct ac97_device *codec;
    codec=(struct ac97_device*)device;
    //PCI Strukturen initialisieren
    DEBUG_MSG("AC97:- Interrupthandler und Ports initialisieren");
    cdi_register_irq(codec->pci->irq,ac97_handle_interrupt,device);
    cdi_pci_alloc_ioports(codec->pci);
    
    cdi_list_t reslist=codec->pci->resources;
    struct cdi_pci_resource* res;
    int i;
    codec->nambar=0;
    codec->nabmbar=0;
    for(i=0; (res=cdi_list_get(reslist,i));i++){
        if((res->type==CDI_PCI_IOPORTS)&&(codec->nabmbar==0)){
            codec->nabmbar=res->start;
            DEBUG_MSG("verm. Nabmbar");
        }
        else if((res->type==CDI_PCI_IOPORTS)&&(codec->nambar==0)){
            DEBUG_MSG("verm. Nambar");
            codec->nambar=res->start;
        }
        else if(res->type==CDI_PCI_IOPORTS){
            DEBUG_MSG("IOPORT unbekannt");
        }
        else{
            DEBUG_MSG("res->type unbekannt");
        }
    }
    cdi_sleep_ms(1000);
    /* Karte Resetten */
    DEBUG_MSG("Karte resetten");
    cdi_outw(codec->nambar+NAM_RESET,42);/*Reset der Karte durchführen*/
    cdi_outb(codec->nabmbar+NABM_GLB_CTRL_STAT,0x02);/*wird auch zum Resetten
benötigt*/
    cdi_sleep_ms(1000); /*1sec warten*/
    
    /* Lautstärke einstellen */
    DEBUG_MSG("Lautstärke einstellen");
    /*Lautstärke geht von 0x00 bis 0x3f, wobei 0x00 laut und 0x3f leise ist*/
    uint16_t volume=0x05;
    cdi_outw(codec->nambar+NAM_MASTER_VOLUME,(volume<<8)|volume);/*Allgemeine Laustärke für
Links und Rechts*/
    cdi_outw(codec->nambar+NAM_MONO_VOLUME,volume);/*Mono Lautstärke*/
    cdi_outw(codec->nambar+NAM_PC_BEEP,volume);/*PC BEEP Lautstärke*/
    cdi_outw(codec->nambar+NAM_PCM_VOLUME,(volume<<8)|volume);/*PCM Lautstärke für links
und rechts*/
    cdi_sleep_ms(1000);/*1sec warten*/
    
    /*Sample rate einstellen*/
    DEBUG_MSG("Sample Rates Einstellen");
    if(!((cdi_inw(codec->nambar+NAM_EXT_AUDIO_ID)&0x01))) /* Is mir nicht ganz klar 
        was das hier macht*/{
        /*Offensichtlich ist das BIT nicht gesetzt, deshalb haben wir eine
SAMPLE RATE von konstant 48kHz*/}
    else
    {
        DEBUG_MSG("Sample Rates Konfigurieren");
        cdi_outw(codec->nambar+NAM_EXT_AUDIO_STC,cdi_inw(codec->nambar+
NAM_EXT_AUDIO_ID)|1); /*Variable Sample Rate*/
        cdi_sleep_ms(1000);/*Gute nacht*/
        cdi_outw(codec->nambar+NAM_FRONT_SPLRATE,44100);/*Front Sample Rate*/
        cdi_outw(codec->nambar+NAM_LR_SPLRATE,44100);/*Links Rechts Sample Rate*/
        cdi_sleep_ms(1000);/*Schlaf schön*/
    }
    /*Buffer initialisieren.*/
    DEBUG_MSG("Bufferlist initialisieren - Nur zum Test, gehört hier nicht hin!");
    codec->valid_buffs=0x00;/*Bisher ist keiner der Buffer gültig*/
    /* Buffer list anlegen*/
    void* paddr_buf_lst;
    if(cdi_alloc_phys_mem(32*sizeof(buf),(void **)&codec->buffer_list,&paddr_buf_lst)==-1){
        DEBUG_MSG("MEMALLOC FEHLGESCHLAGEN!");
        return;
    }
//     DEBUG_MSG("Buffer anlegen, das kann haarig werden.");
    //memset(codec->buffer_list,0,32*sizeof(buf));
    /* Buffer anlegen und eintragen*/
    DEBUG_MSG("Buffer anlegen und eintragen");
    for(i=0;i<32;i++)
    {
        void* vbuf=0;/*virtuelle Adresse des Buffers*/
        void* pbuf=0;/*physische Adresse*/
        if(cdi_alloc_phys_mem(0x10000,&vbuf,&pbuf)==-1){/*0x20000 funzt hier offensichtlich nich*/
            DEBUG_MSG("MEMALLOC FEHLGESCHLAGEN -- BUFFER INITIALISIEREN");
            return;
        }
        /*Buffer füllen*/
        else{
            DEBUG_MSG("Buffer fuettern.");/*Zuviele Debugausgaben*/
            codec->buffer_list[i].buffer=pbuf;/*Physikalische Adresse*/
            DEBUG_MSG("Buffer Phys addr. eingetragen");
            codec->buffer_list[i].sample_length=0x7ffe;/*Maximale Sample Länge*/
            DEBUG_MSG("Buffer Sample lgt eingetragen");
            if(i==31){
                DEBUG_MSG("BUP=1");
                codec->buffer_list[i].bup=1;
            }
            else{
                DEBUG_MSG("BUP=0");
                codec->buffer_list[i].bup=0;
            }
            DEBUG_MSG("Buffer ");
            codec->buffer_list[i].ioc=1;
            int j;
            uint16_t* xbuf=(uint16_t*)vbuf;
            for(j=0;j<0x8000;j+=2)
            {
                xbuf[j]=0x222*(j%60);
                xbuf[j+1]=0x222*(j%60);
//                 printf("%x\n",j%60*0x0222);
            }
            //memset(vbuf,0,0x10000);
        }
    }
    /*cdi_outb(0x61, cdi_inb(0x61) | 3);*//*Das kickt offensichtlich das Programm*/
    DEBUG_MSG("Abspielen!");
    cdi_sleep_ms(1000);/*Immer noch am pennen?!*/
    //for(;;){ /*Besser isses keine Endlosschleife drum zu machen ;-)*/
        //DEBUG_MSG("REEEPLAY!");
        cdi_outl(codec->nabmbar+NABM_POBDBAR,(uint32_t)codec->paddr_buf_list);
        cdi_outb(codec->nabmbar+NABM_POLVI,31);
        cdi_outb(codec->nabmbar+NABM_POCONTROL,0x01);
        //cdi_sleep_ms(100);
   //}
   
}

/*
  TODO: Rausfinden warum ich nix höre ...
   -> Das könnte an der Frequenz meines Sägezahnzeugs liegen. 48000/60 = 800 --> hörbar
   -> Das könnte an der Endianess liegen, da hab ich grade kA
   -> Das könnte an der Benutzung der falschen Register leigen -> auch kA, denn das ist im wesentlichen alles genauso wie in der Wiki ...
*/

void ac97_remove_device(struct cdi_device* device){
    ;
}

static void ac97_handle_interrupt(struct cdi_device* device){
    DEBUG_MSG("Interrupts");
}