
#ifndef __ac97_h__
#define __ac97_h__

#include <stdint.h>

#include "cdi.h"
#include "cdi/net.h"
#include "cdi/pci.h"

/* Benötigte Konstanten */

#define NAM_RESET          0x0000
#define NAM_MASTER_VOLUME  0x0002
#define NAM_MONO_VOLUME    0x0006
#define NAM_PC_BEEP        0x000A
#define NAM_PCM_VOLUME     0x0018
#define NAM_EXT_AUDIO_ID   0x0028
#define NAM_EXT_AUDIO_STC  0x002A
#define NAM_FRONT_SPLRATE  0x002C
#define NAM_LR_SPLRATE     0x0032
#define NABM_POBDBAR       0x0010
#define NABM_POLVI         0x0015
#define NABM_POCONTROL     0x001B
#define NABM_GLB_CTRL_STAT 0x0060

/* Makros */

#define DEBUG_MSG(s) printf("[AC97] debug: %s() '%s'\n", __FUNCTION__, s)

struct ac97_buffer_desc_t{
    void*                   buffer;
    uint16_t                sample_length;
    uint16_t                reserved:14;
    uint16_t                bup:1;
    uint16_t                ioc:1;
    
}__attribute__((packed));

typedef struct ac97_buffer_desc_t buf;

struct ac97_device{
    struct cdi_device cdi;
    struct cdi_pci_device* pci;
    void* phys;
    buf* buffer_list; //Liste der Buffer
    void* paddr_buf_list;//phyisische Adresse der Buffer Descriptor list
    uint32_t valid_buffs; //mini bitmap welche buffer gerade gültig sind :)
    
    uint32_t nambar;
    uint32_t nabmbar;
    
    //Der Rest hat mit der weiteren Planung zu tun. TODO: PLANEN! Davor wohl eher noch TUT LESEN+zur abwechslung mal verstehen :)
    //TODO: Volume, Sample Rates etc.
};

void ac97_init_device(struct cdi_device* device);
void ac97_remove_device(struct cdi_device* device);

#endif

/* EOF */

