#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <stdint.h>

#include "cdi/pci.h"
#include "cdi/io.h"
#include "cdi/misc.h"

#include "includes/ac97.h"

struct ac97_options{
    uint32_t mode;
};

typedef struct ac97_options dro;

struct ac97_driver {
    struct cdi_driver drv;
};

static struct ac97_driver ac97;

static const char* driver_name="ac97";

static void ac97_parameters(dro* modi, int argc, char *argv[]);
static void ac97driver_init(int argc, char *argv[]);
static void ac97driver_destroy(struct cdi_driver* driver);

#ifdef CDI_STANDALONE
int main(int argc, char* argv[])
#else
int init_ac97(int argc, char* argv[])
#endif
{
    cdi_init();
    ac97driver_init(argc,argv);
    cdi_driver_register((struct cdi_driver*) &ac97);
#ifdef CDI_STANDALONE
    cdi_run_drivers();
#endif
    return 0;
}

static void ac97driver_init(int argc, char *argv[]){
    dro options={
        .mode=0x00
    };
    
    ac97_parameters(&options, argc,argv);
    ac97.drv.name=driver_name;
    ac97.drv.type=CDI_UNKNOWN;
    ac97.drv.init_device=ac97_init_device;
    ac97.drv.remove_device=ac97_remove_device;
    ac97.drv.destroy=ac97driver_destroy;
    
    cdi_list_t pci_devices=cdi_list_create();
    cdi_pci_get_all_devices(pci_devices);
    struct cdi_pci_device* get=0;
    int i;
    for(i=0;(get=cdi_list_get(pci_devices,i));i++){
        printf("PCI_DEVICE: %x\n",get->device_id);
        if((get->vendor_id==0x8086)&&(get->device_id==0x2415)){
            void* p_phys_device;
            struct ac97_device* ac97_d;
            if((cdi_alloc_phys_mem(sizeof(*ac97_d),(void**) &ac97_d,&p_phys_device))==-1){
                DEBUG_MSG("Memalloc fehlgeschlagen!");
            }
            memset(ac97_d,0,sizeof(struct ac97_device));//Initialisierung
            ac97_d->phys=p_phys_device;
            ac97_d->pci=get;
            ac97_init_device((struct cdi_device*)ac97_d);
        }
        else{
            cdi_pci_device_destroy(get);
        }
    }
    cdi_list_destroy(pci_devices);
}

static void ac97_parameters(dro* options, int argc, char *argv[]){
    int i;
    for( i=1;i<argc;i++){
        DEBUG_MSG("Unknown ARGS!");
    }
}

static void ac97driver_destroy(struct cdi_driver* driver){
}

/* EOF */
